package com.qmth.distributed.print.business.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.distributed.print.business.bean.marking.GroupInfo;
import com.qmth.distributed.print.business.entity.ExamPaperGroup;
import com.qmth.distributed.print.business.mapper.ExamPaperGroupMapper;
import com.qmth.distributed.print.business.service.ExamPaperGroupMarkerService;
import com.qmth.distributed.print.business.service.ExamPaperGroupService;
import com.qmth.teachcloud.common.base.BaseEntity;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * @Description: 试卷分组服务类
 * @Author: CaoZixuan
 * @Date: 2022-04-13
 */
@Service
public class ExamPaperGroupServiceImpl extends ServiceImpl<ExamPaperGroupMapper, ExamPaperGroup> implements ExamPaperGroupService {
    @Resource
    private ExamPaperGroupMarkerService examPaperGroupMarkerService;

    @Transactional(rollbackFor = Exception.class)
    @Override
    public Long saveExamPaperGroupInfo(Long examPaperStructureId, List<GroupInfo> groupInfo) {

        return null;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void deleteExamPaperGroupInfo(Long examPaperStructureId) {
        // 要删除的分组id集合
        Set<Long> groupIdSet = this.list(new QueryWrapper<ExamPaperGroup>()
                .lambda()
                .eq(ExamPaperGroup::getExamPaperStructureId,examPaperStructureId))
                .stream()
                .map(BaseEntity::getId)
                .collect(Collectors.toSet());

        // 删除评卷员和分组的关系
        examPaperGroupMarkerService.deleteExamPaperGroupMarkerService(groupIdSet);

        // 删除分组信息
        this.removeByIds(groupIdSet);
    }
}
